/******************************************************************************
 * Minimal example for M16C with GCC
 *****************************************************************************/

#define prcr (*((unsigned char *) 0x000A)) /* protect register */
#define pm0  (*((unsigned char *) 0x0004)) /* processor mode 0 register */
#define pd7  (*((unsigned char *) 0x03EF)) // port P7 direction register
#define p7   (*((unsigned char *) 0x03ED)) // port P7 register

/****************************************************************************/

/* #if 0 */
/* void start(void); */
/* typedef void (*ifunc)(void) __attribute__((mode(SI))); */
/* const ifunc __attribute__((section(".resetvec"))) reset_vector = start; */
/* #endif */

/****************************************************************************/

int main(void)
{
    int i;

    prcr = 0x02;
    pm0  = 0x00;
    prcr = 0x00;

    pd7 = 0xFF; // set direction to output

    while (1) {
        p7 = 0x00; // leds off
        i = 1000;
        while (--i); // wait

        p7 = 0x01; // leds on
        i = 1000;
        while (--i); // wait
    }

    return 0;
}

/****************************************************************************/
